' AccountHasReadPermissionsToAuthenticatedUsers.vbs
'
' Portal GuilleSQL
' http://www.guillesql.es
' ---------------------------------------------------------'

SET objRootDSE = GETOBJECT("LDAP://RootDSE") 
 
strRoot = objRootDSE.GET("DefaultNamingContext") 
strfilter = "(&(objectCategory=Person)(objectClass=User))" 
strAttributes = "distinguishedName" 
strScope = "subtree" 
SET cn = CREATEOBJECT("ADODB.Connection") 
SET cmd = CREATEOBJECT("ADODB.Command") 
cn.Provider = "ADsDSOObject" 
cn.Open "Active Directory Provider" 
cmd.ActiveConnection = cn 
 
cmd.Properties("Page Size") = 1000 
 
cmd.commandtext = "<LDAP://" & strRoot & ">;" & strFilter & ";" & strAttributes & ";" & strScope 
 
SET rs = cmd.EXECUTE 
 
Set objFSO=CreateObject("Scripting.FileSystemObject")
Set objFile = objFSO.CreateTextFile("output.txt",True)

while rs.EOF=false
    objFile.Write rs.Fields(0).Value & ";" & AccountHasReadPermissionsToAuthenticatedUsers(rs.Fields(0).Value) & vbCrLf
    rs.MoveNext
wend

objFile.Close
 
rs.close 
cn.close 

WScript.Echo "Finished !"






 
Function AccountHasReadPermissionsToAuthenticatedUsers(strLDAP)
    Const ADS_RIGHT_READ_CONTROL = &H20000

    Set objUser = GetObject("LDAP://" & strLDAP)
    Set objNtSecurityDescriptor = objUser.Get("ntSecurityDescriptor")
    Set objDiscretionaryAcl = objNtSecurityDescriptor.DiscretionaryAcl

    intAccountHasReadPermissionsToAuthenticatedUsers = 0
    For Each objAce In objDiscretionaryAcl
        If (objAce.Trustee = "NT AUTHORITY\Authenticated Users") And (objAce.AccessMask And ADS_RIGHT_READ_CONTROL) Then 
           intAccountHasReadPermissionsToAuthenticatedUsers = 1
        End If
    Next

    AccountHasReadPermissionsToAuthenticatedUsers = intAccountHasReadPermissionsToAuthenticatedUsers
End Function
 
